"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Model = void 0;
var tslib_1 = require("tslib");
var core_1 = require("../core");
var ReactRedux = tslib_1.__importStar(require("react-redux"));
var ComposeAction_1 = require("../actions/ComposeAction");
var Model = /** @class */ (function (_super) {
    tslib_1.__extends(Model, _super);
    function Model() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Model.useLoading = function () {
        var actions = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            actions[_i] = arguments[_i];
        }
        return actions.reduce(function (carry, action) {
            // Hooks shouldn't be in condition statement
            var useLoading = action.useLoading();
            return carry || useLoading;
        }, false);
    };
    Model.prototype.useData = function (filter) {
        var _this = this;
        return ReactRedux.useSelector(function () {
            return filter ? filter(_this.data) : _this.data;
        });
    };
    Model.prototype.compose = function (fn) {
        var action = new ComposeAction_1.ComposeAction(this, fn);
        return action;
    };
    return Model;
}(core_1.BaseModel));
exports.Model = Model;
